package com.gic.haoban.manage.service.service.out.impl;


import com.gic.haoban.base.api.common.BasePageInfo;
import com.gic.haoban.base.api.common.ServiceResponse;
import com.gic.haoban.common.utils.PageUtil;
import com.gic.haoban.manage.api.dto.*;

import java.util.Collections;
import java.util.Date;
import java.util.List;

import com.gic.haoban.manage.service.dao.mapper.MemberUnionidRelatedMapper;
import com.gic.haoban.manage.service.entity.MemberUnionidRelated;
import com.github.pagehelper.PageInfo;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.gic.api.base.commons.Page;
import com.gic.commons.util.EntityUtil;
import com.gic.haoban.manage.api.service.ExternalClerkRelatedApiService;
import com.gic.haoban.manage.service.dao.mapper.TabHaobanExternalClerkRelatedMapper;
import com.gic.haoban.manage.service.entity.TabHaobanExternalClerkRelated;
import com.github.pagehelper.PageHelper;

@Service
public class ExternalClerkRelatedApiServiceImpl implements ExternalClerkRelatedApiService{
	private static final Logger log = LogManager.getLogger(ExternalClerkRelatedApiServiceImpl.class);
	@Autowired
	private TabHaobanExternalClerkRelatedMapper tabHaobanExternalClerkRelatedMapper;

    @Autowired
    private MemberUnionidRelatedMapper memberUnionidRelatedMapper;

	@Override
	public List<ExternalClerkRelatedDTO> listByEnterpriseIdAndDate(
			String enterpriseId, Date date) {
		List<TabHaobanExternalClerkRelated> list = tabHaobanExternalClerkRelatedMapper.listByEnterpriseIdAndDate(enterpriseId,date);
		return EntityUtil.changeEntityListByJSON(ExternalClerkRelatedDTO.class,list);	
	}
	@Override
	public Page<ExternalClerkRelatedDTO> pageMemberUnionByParams(List<String> userIdList, List<String> sendMemberIds,
			String enterpriseId, BasePageInfo pageInfo) {
		PageHelper.startPage(pageInfo.getPageNum(), pageInfo.getPageSize());
		return  PageUtil.changePageHelperToCurrentPage(tabHaobanExternalClerkRelatedMapper.pageMemberUnionByParams(userIdList,sendMemberIds,enterpriseId),ExternalClerkRelatedDTO.class);
	}
	@Override
	public List<ExternalClerkRelatedDTO> listByWxEnterpriseIdAndWxUserId(String wxUserId, String wxEnterpriseId) {
		
		return EntityUtil.changeEntityListByJSON(ExternalClerkRelatedDTO.class, tabHaobanExternalClerkRelatedMapper.listByWxEnterpriseIdAndWxUserId(wxUserId,wxEnterpriseId));
	}
	@Override
	public List<ExternalClerkRelatedDTO> listByWxEnterpriseIdAndWxUserIds(List<String> userIdList,
			String wxEnterpriseId) {
		if(userIdList == null || userIdList.isEmpty()){
			return Collections.EMPTY_LIST;
		}
		return EntityUtil.changeEntityListByJSON(ExternalClerkRelatedDTO.class, tabHaobanExternalClerkRelatedMapper.listByWxEnterpriseIdAndWxUserIds(userIdList,wxEnterpriseId));
	}

	@Override
	public ExternalClerkRelatedDTO getExternalClerkByRelationKeyAndPre(String relationKey) {
		TabHaobanExternalClerkRelated related = tabHaobanExternalClerkRelatedMapper.getByRelationKey(relationKey);
		return EntityUtil.changeEntityNew(ExternalClerkRelatedDTO.class, related);
	}

	@Override
	public Page<ExternalClerkRelatedDTO> pageExternalClerk(String wxEnterpriseId, String wxUserId, List<Integer> statusFlags, BasePageInfo pageInfo) {
		PageHelper.startPage(pageInfo);
		List<TabHaobanExternalClerkRelated> ret = tabHaobanExternalClerkRelatedMapper.listByWxEnterpriseIdAndWxUserIdAndStatus(wxEnterpriseId, wxUserId, statusFlags);
		Page<ExternalClerkRelatedDTO> retPage = PageUtil.changePageHelperToCurrentPage(new PageInfo<>(ret), ExternalClerkRelatedDTO.class);
        return retPage;
    }

	@Override
	public boolean pushExternalByRelationKey(String relationKey) {
		tabHaobanExternalClerkRelatedMapper.pushExternalByRelationKey(relationKey);
		return true;
	}

	@Override
	public ServiceResponse<ExternalClerkRelatedDTO> bindMemberIdExternalByRelationKey(String relationKey, String enterpriseId, String memberId, String unionid) {
		ServiceResponse<ExternalClerkRelatedDTO> resp = new ServiceResponse<>();
		TabHaobanExternalClerkRelated externalClerkRelated = tabHaobanExternalClerkRelatedMapper.getByRelationKey(relationKey);
		if (null == externalClerkRelated) {
            resp.setCode(0);
            resp.setMessage("relationKey对应的关联关系不存在或删除");
			return resp;
		}
		if (!externalClerkRelated.getEnterpriseId().equals(enterpriseId)) {
            resp.setCode(0);
            resp.setMessage("relationKey对应的企业与所传会员企业不对应");
			return resp;
		}
		externalClerkRelated.setMemberId(memberId);
		externalClerkRelated.setUnionid(unionid);
		externalClerkRelated.setUpdateTime(new Date());
        externalClerkRelated.setStatusFlag(1);
        tabHaobanExternalClerkRelatedMapper.updateByPrimaryKeySelective(externalClerkRelated);
        //更新unionid
        MemberUnionidRelated memberUnionidRelated = memberUnionidRelatedMapper.selectByPrimaryKey(externalClerkRelated.getMemberUnionidRelatedId());
        memberUnionidRelated.setUnionid(unionid);
        memberUnionidRelated.setUpdateTime(new Date());
        memberUnionidRelatedMapper.updateByPrimaryKeySelective(memberUnionidRelated);

		resp.setResult(EntityUtil.changeEntityNew(ExternalClerkRelatedDTO.class, externalClerkRelated));
		return resp;
	}

	@Override
	public ExternalClerkRelatedDTO getClerkFriendByUnionid(String enterpriseId, String clerkId, String unionid) {
		TabHaobanExternalClerkRelated externalClerkRelated = tabHaobanExternalClerkRelatedMapper.getClerkExternalByUnionId(enterpriseId, clerkId, unionid);
		ExternalClerkRelatedDTO clerkRelatedDTO = EntityUtil.changeEntityNew(ExternalClerkRelatedDTO.class, externalClerkRelated);
		return clerkRelatedDTO;
	}

	@Override
	public List<ExternalClerkRelatedDTO> listExternalClerkByWxUserIdAncExternalUserId(String wxEnterpriseId, String wxUserId, String enterpriseId, String externalUserId) {
		List<TabHaobanExternalClerkRelated> list = tabHaobanExternalClerkRelatedMapper.listExternalClerkByWxUserIdAncExternalUserId(wxEnterpriseId, wxUserId, enterpriseId, externalUserId);
		return EntityUtil.changeEntityListNew(ExternalClerkRelatedDTO.class, list);
	}
}
